package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.service.TowerProjectBuildingService;
import com.gxwebsoft.tower.entity.TowerProjectBuilding;
import com.gxwebsoft.tower.param.TowerProjectBuildingParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 项目标地控制器
 *
 * @author 科技小王子
 * @since 2024-01-05 22:01:16
 */
@Api(tags = "项目标地管理")
@RestController
@RequestMapping("/api/tower/tower-project-building")
public class TowerProjectBuildingController extends BaseController {
    @Resource
    private TowerProjectBuildingService towerProjectBuildingService;

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:list')")
    @OperationLog
    @ApiOperation("分页查询项目标地")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerProjectBuilding>> page(TowerProjectBuildingParam param) {
        PageParam<TowerProjectBuilding, TowerProjectBuildingParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerProjectBuildingService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(towerProjectBuildingService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:list')")
    @OperationLog
    @ApiOperation("查询全部项目标地")
    @GetMapping()
    public ApiResult<List<TowerProjectBuilding>> list(TowerProjectBuildingParam param) {
        PageParam<TowerProjectBuilding, TowerProjectBuildingParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerProjectBuildingService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(towerProjectBuildingService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:list')")
    @OperationLog
    @ApiOperation("根据id查询项目标地")
    @GetMapping("/{id}")
    public ApiResult<TowerProjectBuilding> get(@PathVariable("id") Integer id) {
        return success(towerProjectBuildingService.getById(id));
        // 使用关联查询
        //return success(towerProjectBuildingService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:save')")
    @OperationLog
    @ApiOperation("添加项目标地")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerProjectBuilding towerProjectBuilding) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerProjectBuilding.setUserId(loginUser.getUserId());
        }
        if (towerProjectBuildingService.save(towerProjectBuilding)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:update')")
    @OperationLog
    @ApiOperation("修改项目标地")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerProjectBuilding towerProjectBuilding) {
        if (towerProjectBuildingService.updateById(towerProjectBuilding)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:remove')")
    @OperationLog
    @ApiOperation("删除项目标地")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerProjectBuildingService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:save')")
    @OperationLog
    @ApiOperation("批量添加项目标地")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerProjectBuilding> list) {
        if (towerProjectBuildingService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:update')")
    @OperationLog
    @ApiOperation("批量修改项目标地")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerProjectBuilding> batchParam) {
        if (batchParam.update(towerProjectBuildingService, "building_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProjectBuilding:remove')")
    @OperationLog
    @ApiOperation("批量删除项目标地")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerProjectBuildingService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
